--- vcl.orig/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 12:34:41.000000000 +0100
+++ vcl/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 13:19:37.000000000 +0100
@@ -2160,40 +2166,37 @@
                                          const ImplControlValue& aValue,
                                          const OUString& rCaption )
 {
-	Rectangle		pixmapRect;
-	Rectangle		buttonRect;
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	Rectangle		arrowRect;
-    gint			x,y;
-    GdkRectangle	clipRect;
-
-	NWEnsureGTKButton( m_nScreen );
-	NWEnsureGTKArrow( m_nScreen );
-	NWEnsureGTKCombo( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    Rectangle       pixmapRect;
+    Rectangle       buttonRect;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    Rectangle       arrowRect;
+    gint            x,y;
+    GdkRectangle    clipRect;
 
-	// Find the overall bounding rect of the buttons's drawing area,
-	// plus its actual draw rect excluding adornment
-	pixmapRect = rControlRectangle;
+    NWEnsureGTKButton( m_nScreen );
+    NWEnsureGTKComboBoxEntry( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+
+    // Find the overall bounding rect of the buttons's drawing area,
+    // plus its actual draw rect excluding adornment
+    pixmapRect = rControlRectangle;
     x = rControlRectangle.Left();
     y = rControlRectangle.Top();
 
-	NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
-	NWSetWidgetState( gWidgetData[m_nScreen].gComboWidget, nState, stateType );
-	NWSetWidgetState( gWidgetData[m_nScreen].gArrowWidget, nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gComboBoxEntryWidget, nState, stateType );
 
-    buttonRect = NWGetComboBoxButtonRect( m_nScreen, nType, PART_BUTTON_DOWN, pixmapRect, nState, aValue, rCaption );
+    buttonRect = NWGetComboBoxEntryButtonRect( m_nScreen, nType, PART_BUTTON_DOWN, pixmapRect, nState, aValue, rCaption );
     if( nPart == PART_BUTTON_DOWN )
         buttonRect.Left() += 1;
 
-	Rectangle		aEditBoxRect( pixmapRect );
-	aEditBoxRect.SetSize( Size( pixmapRect.GetWidth() - buttonRect.GetWidth(), aEditBoxRect.GetHeight() ) );
+    Rectangle       aEditBoxRect( pixmapRect );
+    aEditBoxRect.SetSize( Size( pixmapRect.GetWidth() - buttonRect.GetWidth(), aEditBoxRect.GetHeight() ) );
 
-    #define ARROW_EXTENT		0.7
-	arrowRect.SetSize( Size( (gint)(MIN_ARROW_SIZE * ARROW_EXTENT),
-	                         (gint)(MIN_ARROW_SIZE * ARROW_EXTENT) ) );
-	arrowRect.SetPos( Point( buttonRect.Left() + (gint)((buttonRect.GetWidth() - arrowRect.GetWidth()) / 2),
+    arrowRect.SetSize( Size( (gint)(MIN_ARROW_SIZE * ARROW_EXTENT),
+                             (gint)(MIN_ARROW_SIZE * ARROW_EXTENT) ) );
+    arrowRect.SetPos( Point( buttonRect.Left() + (gint)((buttonRect.GetWidth() - arrowRect.GetWidth()) / 2),
                              buttonRect.Top() + (gint)((buttonRect.GetHeight() - arrowRect.GetHeight()) / 2) ) );
 
     for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it )
@@ -2213,48 +2216,163 @@
                             x+(buttonRect.Left() - pixmapRect.Left()), 
                             y+(buttonRect.Top() - pixmapRect.Top()),
                             buttonRect.GetWidth(), buttonRect.GetHeight() );
-        gtk_paint_box( GTK_COMBO(gWidgetData[m_nScreen].gComboWidget)->button->style, gdkDrawable, stateType, shadowType,
-                       &clipRect, GTK_COMBO(gWidgetData[m_nScreen].gComboWidget)->button, "button",
+        gtk_paint_box( gWidgetData[m_nScreen].gComboBoxEntry_ButtonWidget->style, gdkDrawable, stateType, shadowType,
+                       &clipRect, gWidgetData[m_nScreen].gComboBoxEntry_ButtonWidget, "button",
                        x+(buttonRect.Left() - pixmapRect.Left()), 
                        y+(buttonRect.Top() - pixmapRect.Top()),
                        buttonRect.GetWidth(), buttonRect.GetHeight() );
 
-        gtk_paint_arrow( gWidgetData[m_nScreen].gArrowWidget->style, gdkDrawable, stateType, shadowType,
-                         &clipRect, gWidgetData[m_nScreen].gArrowWidget, "arrow", GTK_ARROW_DOWN, TRUE,
+        gtk_paint_arrow( gWidgetData[m_nScreen].gComboBoxEntry_ArrowWidget->style, gdkDrawable, stateType, shadowType,
+                         &clipRect, gWidgetData[m_nScreen].gComboBoxEntry_ArrowWidget, "arrow", GTK_ARROW_DOWN, TRUE,
                          x+(arrowRect.Left() - pixmapRect.Left()), y+(arrowRect.Top() - pixmapRect.Top()),
                          arrowRect.GetWidth(), arrowRect.GetHeight() );
     }
     
-	return( TRUE );
+    return( TRUE );
+}
+
+BOOL GtkSalGraphics::NWPaintGTKComboBox( GdkDrawable* gdkDrawable,
+                                         ControlType nType, ControlPart nPart,
+                                         const Rectangle& rControlRectangle,
+                                         const clipList& rClipList,
+                                         ControlState nState, 
+                                         const ImplControlValue& aValue,
+                                         const OUString& rCaption )
+{
+    Rectangle       pixmapRect;
+    Rectangle       buttonRect;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    Rectangle       arrowRect;
+    gint            x,y;
+    GdkRectangle    clipRect;
+
+    NWEnsureGTKButton( m_nScreen );
+    NWEnsureGTKComboBox( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+
+    // Find the overall bounding rect of the buttons's drawing area,
+    // plus its actual draw rect excluding adornment
+    pixmapRect = rControlRectangle;
+    if ( nPart == PART_WINDOW )
+    {
+        // Make the widget a _bit_ bigger
+        pixmapRect.SetPos( Point( pixmapRect.Left() - 1,
+                                  pixmapRect.Top() - 1 ) );
+        pixmapRect.SetSize( Size( pixmapRect.GetWidth() + 2,
+                                  pixmapRect.GetHeight() + 2 ) );
+    }
+    x = pixmapRect.Left();
+    y = pixmapRect.Top();
+
+    NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gComboBoxWidget, nState, stateType );
+
+    buttonRect = NWGetComboBoxButtonRect( m_nScreen, nType, PART_BUTTON_DOWN, pixmapRect, nState, aValue, rCaption );
+    if( nPart == PART_BUTTON_DOWN )
+        buttonRect.Left() += 1;
+
+    arrowRect.SetSize( Size( (gint)(MIN_ARROW_SIZE * ARROW_EXTENT),
+                             (gint)(MIN_ARROW_SIZE * ARROW_EXTENT) ) );
+    arrowRect.SetPos( Point( buttonRect.Left() + (gint)((buttonRect.GetWidth() - arrowRect.GetWidth()) / 2),
+                             buttonRect.Top() + (gint)((buttonRect.GetHeight() - arrowRect.GetHeight()) / 2) ) );
+
+    for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it )
+    {
+        clipRect.x = it->Left();
+        clipRect.y = it->Top();
+        clipRect.width = it->GetWidth();
+        clipRect.height = it->GetHeight();
+        
+        if ( nPart != PART_WINDOW )
+        {
+            // Buttons must paint opaque since some themes have alpha-channel enabled buttons
+            gtk_paint_flat_box( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, GTK_STATE_NORMAL, GTK_SHADOW_NONE, 
+                                &clipRect, m_pWindow, "base", 
+                                x+(pixmapRect.Left() - pixmapRect.Left()), 
+                                y+(pixmapRect.Top() - pixmapRect.Top()),
+                                pixmapRect.GetWidth(), pixmapRect.GetHeight() );
+
+            gtk_paint_box( gWidgetData[m_nScreen].gComboBox_ButtonWidget->style, gdkDrawable, stateType, shadowType,
+                           &clipRect, gWidgetData[m_nScreen].gComboBox_ButtonWidget, "button",
+                           x+(pixmapRect.Left() - pixmapRect.Left()), 
+                           y+(pixmapRect.Top() - pixmapRect.Top()),
+                           pixmapRect.GetWidth(), pixmapRect.GetHeight() );
+
+            gtk_paint_arrow( gWidgetData[m_nScreen].gComboBox_ArrowWidget->style, gdkDrawable, stateType, shadowType,
+                             &clipRect, gWidgetData[m_nScreen].gComboBox_ArrowWidget, "arrow", GTK_ARROW_DOWN, TRUE,
+                             x+(arrowRect.Left() - pixmapRect.Left()), y+(arrowRect.Top() - pixmapRect.Top()),
+                             arrowRect.GetWidth(), arrowRect.GetHeight() );
+
+            if (gWidgetData[m_nScreen].gComboBox_SeparatorWidget)
+            {
+                gint nSeparatorWidth;
+                gboolean bWideSeparators;
+                gtk_widget_style_get(gWidgetData[m_nScreen].gComboBox_SeparatorWidget,
+                    "wide-separators", &bWideSeparators,
+                    "separator-width", &nSeparatorWidth,
+                    NULL);
+
+                if (bWideSeparators)
+                {
+                    gtk_paint_box(gWidgetData[m_nScreen].gComboBox_SeparatorWidget->style,
+                        gdkDrawable, GTK_STATE_NORMAL, GTK_SHADOW_ETCHED_OUT,
+                        &clipRect, gWidgetData[m_nScreen].gComboBox_SeparatorWidget,
+                        "vseparator", x+(arrowRect.Left() - pixmapRect.Left()-nSeparatorWidth),
+                        y+(arrowRect.Top() - pixmapRect.Top()), nSeparatorWidth, arrowRect.GetHeight());
+                }
+                else
+                {
+                    gtk_paint_vline(gWidgetData[m_nScreen].gComboBox_SeparatorWidget->style,
+                        gdkDrawable, GTK_STATE_NORMAL, &clipRect,
+                        gWidgetData[m_nScreen].gComboBox_SeparatorWidget, "vseparator",
+                        y+(arrowRect.Top() - pixmapRect.Top()), y+(arrowRect.Top() - pixmapRect.Top()) + arrowRect.GetHeight(),
+                        x+(arrowRect.Left() - pixmapRect.Left())-
+                            gWidgetData[m_nScreen].gComboBox_SeparatorWidget->style->xthickness);
+                }
+            }
+        }
+        else
+        {
+            NWEnsureGTKScrolledWindow(m_nScreen);
+
+            gtk_paint_shadow( gWidgetData[m_nScreen].gScrolledWindowWidget->style, gdkDrawable,
+                GTK_STATE_NORMAL, GTK_SHADOW_IN, &clipRect,
+                gWidgetData[m_nScreen].gScrolledWindowWidget, "scrolled_window",
+                x, y, pixmapRect.GetWidth(), pixmapRect.GetHeight() );
+        }
+    }
+    
+    return( TRUE );
 }
 
 //----
 
-static Rectangle NWGetComboBoxButtonRect( int nScreen,
+static Rectangle NWGetComboBoxEntryButtonRect( int nScreen,
                                           ControlType,
-									      ControlPart nPart,
-                                          Rectangle				aAreaRect,
+                                          ControlPart nPart,
+                                          Rectangle             aAreaRect,
                                           ControlState,
                                           const ImplControlValue&,
                                           const OUString& )
 {
-	Rectangle	aButtonRect;
-	gint		nArrowWidth;
+    Rectangle   aButtonRect;
+    gint        nArrowWidth;
     gint        nButtonWidth;
-	gint		nFocusWidth;
-	gint		nFocusPad;
+    gint        nFocusWidth;
+    gint        nFocusPad;
 
-	NWEnsureGTKArrow( nScreen );
+    NWEnsureGTKComboBoxEntry ( nScreen );
 
-	// Grab some button style attributes
-	gtk_widget_style_get( gWidgetData[nScreen].gDropdownWidget,
-                                  	"focus-line-width",	&nFocusWidth,
-									"focus-padding", 	&nFocusPad, (char *)NULL );
+    // Grab some button style attributes
+    gtk_widget_style_get( gWidgetData[nScreen].gComboBoxEntry_ButtonWidget,
+                                    "focus-line-width", &nFocusWidth,
+                                    "focus-padding",    &nFocusPad, (char *)NULL );
 
-	nArrowWidth = MIN_ARROW_SIZE + (GTK_MISC(gWidgetData[nScreen].gArrowWidget)->xpad * 2);
+    nArrowWidth = MIN_ARROW_SIZE + (GTK_MISC(gWidgetData[nScreen].gComboBoxEntry_ArrowWidget)->xpad * 2);
     nButtonWidth = nArrowWidth +
-                   ((BTN_CHILD_SPACING + gWidgetData[nScreen].gDropdownWidget->style->xthickness) * 2)
-				   + (2 * (nFocusWidth+nFocusPad));
+                   ((BTN_CHILD_SPACING + gWidgetData[nScreen].gComboBoxEntry_ButtonWidget->style->xthickness) * 2)
+                   + (2 * (nFocusWidth+nFocusPad));
     if( nPart == PART_BUTTON_DOWN )
     {
         aButtonRect.SetSize( Size( nButtonWidth, aAreaRect.GetHeight() ) );
@@ -2263,13 +2381,11 @@
     }
     else if( nPart == PART_SUB_EDIT )
     {
-        NWEnsureGTKCombo( nScreen );
-        
-        gint adjust_x = GTK_CONTAINER(gWidgetData[nScreen].gComboWidget)->border_width +
+        gint adjust_x = GTK_CONTAINER(gWidgetData[nScreen].gComboBoxEntryWidget)->border_width +
                         nFocusWidth +
                         nFocusPad;
-        gint adjust_y = adjust_x + gWidgetData[nScreen].gComboWidget->style->ythickness;
-        adjust_x     += gWidgetData[nScreen].gComboWidget->style->xthickness;
+        gint adjust_y = adjust_x + gWidgetData[nScreen].gComboBoxEntryWidget->style->ythickness;
+        adjust_x     += gWidgetData[nScreen].gComboBoxEntryWidget->style->xthickness;
         aButtonRect.SetSize( Size( aAreaRect.GetWidth() - nButtonWidth - 2 * adjust_x,
                                    aAreaRect.GetHeight() - 2 * adjust_y ) );
         Point aEditPos = aAreaRect.TopLeft();
@@ -2281,22 +2397,86 @@
 	return( aButtonRect );
 }
 
-//-------------------------------------
+static Rectangle NWGetComboBoxButtonRect( int nScreen,
+                                          ControlType,
+                                          ControlPart nPart,
+                                          Rectangle             aAreaRect,
+                                          ControlState,
+                                          const ImplControlValue&,
+                                          const OUString& )
+{
+    Rectangle   aButtonRect;
+    gint        nArrowWidth;
+    gint        nButtonWidth;
+    gint        nFocusWidth;
+    gint        nFocusPad;
 
+    NWEnsureGTKComboBox ( nScreen );
+    // Grab some button style attributes
+    gtk_widget_style_get( gWidgetData[nScreen].gComboBox_ButtonWidget,
+                                    "focus-line-width", &nFocusWidth,
+                                    "focus-padding",    &nFocusPad, (char *)NULL );
 
-    
-BOOL GtkSalGraphics::NWPaintGTKTabItem( ControlType nType, ControlPart,
-                                        const Rectangle& rControlRectangle,
-                                        const clipList&,
-                                        ControlState nState, 
-                                        const ImplControlValue& aValue,
-                                        const OUString& )
-{
-    OSL_ASSERT( nType != CTRL_TAB_ITEM || aValue.getType() == CTRL_TAB_ITEM );
-	GdkPixmap *	pixmap;
-	Rectangle		pixmapRect;
-	Rectangle		tabRect;
-	GtkStateType	stateType;
+    nArrowWidth = MIN_ARROW_SIZE + (GTK_MISC(gWidgetData[nScreen].gComboBox_ArrowWidget)->xpad * 2);
+
+    gint nSeparatorWidth = 0;
+    if (gWidgetData[nScreen].gComboBox_SeparatorWidget)
+    {
+        gboolean bWideSeparators;
+        gtk_widget_style_get(gWidgetData[nScreen].gComboBox_SeparatorWidget,
+                             "wide-separators", &bWideSeparators,
+                             "separator-width", &nSeparatorWidth,
+                             NULL);
+
+        if (!bWideSeparators)
+            nSeparatorWidth = gWidgetData[nScreen].gComboBox_SeparatorWidget->style->xthickness;
+    }
+
+    nButtonWidth = nArrowWidth + nSeparatorWidth +
+                   + gWidgetData[nScreen].gComboBox_ButtonWidget->style->xthickness
+                   + (nFocusWidth+nFocusPad);
+
+    if( nPart == PART_BUTTON_DOWN )
+    {
+        aButtonRect.SetSize( Size( nButtonWidth, aAreaRect.GetHeight() ) );
+        aButtonRect.SetPos( Point( aAreaRect.Left() + aAreaRect.GetWidth() - nButtonWidth,
+                                   aAreaRect.Top() ) );
+    }
+    else if( nPart == PART_SUB_EDIT )
+    {
+        gint adjust_x = GTK_CONTAINER(gWidgetData[nScreen].gComboBoxWidget)->border_width +
+                        nFocusWidth +
+                        nFocusPad;
+        gint adjust_y = adjust_x + gWidgetData[nScreen].gComboBoxWidget->style->ythickness;
+        adjust_x     += gWidgetData[nScreen].gComboBoxWidget->style->xthickness;
+        aButtonRect.SetSize( Size( aAreaRect.GetWidth() - nButtonWidth - 2 * adjust_x,
+                                   aAreaRect.GetHeight() - 2 * adjust_y ) );
+        Point aEditPos = aAreaRect.TopLeft();
+        aEditPos.X() += adjust_x;
+        aEditPos.Y() += adjust_y;
+        aButtonRect.SetPos( aEditPos );
+    }
+
+    return( aButtonRect );
+}
+
+
+//-------------------------------------
+
+
+    
+BOOL GtkSalGraphics::NWPaintGTKTabItem( ControlType nType, ControlPart,
+                                        const Rectangle& rControlRectangle,
+                                        const clipList&,
+                                        ControlState nState, 
+                                        const ImplControlValue& aValue,
+                                        const OUString& )
+{
+    OSL_ASSERT( nType != CTRL_TAB_ITEM || aValue.getType() == CTRL_TAB_ITEM );
+	GdkPixmap *	pixmap;
+	Rectangle		pixmapRect;
+	Rectangle		tabRect;
+	GtkStateType	stateType;
 	GtkShadowType	shadowType;
     if( ! gWidgetData[ m_nScreen ].gCacheTabItems )
     {
@@ -2366,7 +2546,7 @@
     }
 
         
-//	gtk_widget_set_state( gWidgetData[m_nScreen].gNotebookWidget, stateType );
+//  gtk_widget_set_state( gWidgetData[m_nScreen].gNotebookWidget, stateType );
 
     pixmap = gdk_pixmap_new( NULL, pixmapRect.GetWidth(), pixmapRect.GetHeight(), 
                              GetX11SalData()->GetDisplay()->GetVisual( m_nScreen ).GetDepth() );
@@ -2376,42 +2556,42 @@
     paintRect.height = pixmapRect.GetHeight();
                              
     gtk_paint_flat_box( m_pWindow->style, pixmap, GTK_STATE_NORMAL, 
-		                GTK_SHADOW_NONE, &paintRect, m_pWindow, "base", 0, 0, -1, -1);
+                        GTK_SHADOW_NONE, &paintRect, m_pWindow, "base", 0, 0, -1, -1);
 
-	NWSetWidgetState( gWidgetData[m_nScreen].gNotebookWidget, nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gNotebookWidget, nState, stateType );
     
-	switch( nType )
-	{
-		case CTRL_TAB_BODY:
-			break;
+    switch( nType )
+    {
+        case CTRL_TAB_BODY:
+            break;
 
-		case CTRL_FIXEDBORDER:
-		case CTRL_TAB_PANE:
-			gtk_paint_box_gap( gWidgetData[m_nScreen].gNotebookWidget->style, pixmap, GTK_STATE_NORMAL, GTK_SHADOW_OUT, NULL, gWidgetData[m_nScreen].gNotebookWidget,
-				(char *)"notebook", 0, 0, pixmapRect.GetWidth(), pixmapRect.GetHeight(), GTK_POS_TOP, 0, 0 );
-			break;
-
-		case CTRL_TAB_ITEM:
-			stateType = ( nState & CTRL_STATE_SELECTED ) ? GTK_STATE_NORMAL : GTK_STATE_ACTIVE;
-
-			gtk_paint_extension( gWidgetData[m_nScreen].gNotebookWidget->style, pixmap, stateType, GTK_SHADOW_OUT, NULL, gWidgetData[m_nScreen].gNotebookWidget,
-				(char *)"tab", (tabRect.Left() - pixmapRect.Left()), (tabRect.Top() - pixmapRect.Top()),
-				tabRect.GetWidth(), tabRect.GetHeight(), GTK_POS_BOTTOM );
-
-			if ( nState & CTRL_STATE_SELECTED )
-			{
-				gtk_paint_flat_box( gWidgetData[m_nScreen].gNotebookWidget->style, pixmap, stateType, GTK_SHADOW_NONE, NULL, m_pWindow,
-					(char *)"base", 0, (pixmapRect.GetHeight() - 1), pixmapRect.GetWidth(), 1 );
-			}
-			break;
+        case CTRL_FIXEDBORDER:
+        case CTRL_TAB_PANE:
+            gtk_paint_box_gap( gWidgetData[m_nScreen].gNotebookWidget->style, pixmap, GTK_STATE_NORMAL, GTK_SHADOW_OUT, NULL, gWidgetData[m_nScreen].gNotebookWidget,
+                (char *)"notebook", 0, 0, pixmapRect.GetWidth(), pixmapRect.GetHeight(), GTK_POS_TOP, 0, 0 );
+            break;
 
-		default:
-			break;
-	}
+        case CTRL_TAB_ITEM:
+            stateType = ( nState & CTRL_STATE_SELECTED ) ? GTK_STATE_NORMAL : GTK_STATE_ACTIVE;
+
+            gtk_paint_extension( gWidgetData[m_nScreen].gNotebookWidget->style, pixmap, stateType, GTK_SHADOW_OUT, NULL, gWidgetData[m_nScreen].gNotebookWidget,
+                (char *)"tab", (tabRect.Left() - pixmapRect.Left()), (tabRect.Top() - pixmapRect.Top()),
+                tabRect.GetWidth(), tabRect.GetHeight(), GTK_POS_BOTTOM );
+
+            if ( nState & CTRL_STATE_SELECTED )
+            {
+                gtk_paint_flat_box( gWidgetData[m_nScreen].gNotebookWidget->style, pixmap, stateType, GTK_SHADOW_NONE, NULL, m_pWindow,
+                    (char *)"base", 0, (pixmapRect.GetHeight() - 1), pixmapRect.GetWidth(), 1 );
+            }
+            break;
+
+        default:
+            break;
+    }
 
-	// Crux seems to think it can make the pane without a left edge
-	if ( nType == CTRL_FIXEDBORDER )
-		pixmapRect.Move( 1, 0 );
+    // Crux seems to think it can make the pane without a left edge
+    if ( nType == CTRL_FIXEDBORDER )
+        pixmapRect.Move( 1, 0 );
 
     // cache data
     if( nType == CTRL_TAB_ITEM )
@@ -2419,152 +2599,65 @@
     else
         aCachePage.Fill( nType, nState, pixmapRect, pixmap );
         
-	BOOL bSuccess = NWRenderPixmapToScreen(pixmap, pixmapRect);
-	g_object_unref( pixmap );
-	return bSuccess;
+    BOOL bSuccess = NWRenderPixmapToScreen(pixmap, pixmapRect);
+    g_object_unref( pixmap );
+    return bSuccess;
 }
 
-//-------------------------------------
-
-BOOL GtkSalGraphics::NWPaintGTKListBox( GdkDrawable* gdkDrawable,
-                                        ControlType nType, ControlPart nPart,
-                                        const Rectangle& rControlRectangle,
-                                        const clipList& rClipList,
-                                        ControlState nState, 
-                                        const ImplControlValue& aValue,
-                                        const OUString& rCaption )
+static void set_widget_orientation(GtkWidget *widget, GtkOrientation orientation)
 {
-	Rectangle		pixmapRect;
-	Rectangle		widgetRect;
-	Rectangle		aIndicatorRect;
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	gint			bInteriorFocus;
-	gint			nFocusLineWidth;
-	gint			nFocusPadding;
-    gint			x,y;
-    GdkRectangle    clipRect;
-
-	NWEnsureGTKButton( m_nScreen );
-	NWEnsureGTKOptionMenu( m_nScreen );
-	NWEnsureGTKScrolledWindow( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
-
-	// Find the overall bounding rect of the buttons's drawing area,
-	// plus its actual draw rect excluding adornment
-	pixmapRect = rControlRectangle;
-	if ( nPart == PART_WINDOW )
-	{
-		// Make the widget a _bit_ bigger
-		pixmapRect.SetPos( Point( pixmapRect.Left() - 1,
-                                  pixmapRect.Top() - 1 ) );
-		pixmapRect.SetSize( Size( pixmapRect.GetWidth() + 2,
-		                          pixmapRect.GetHeight() + 2 ) );
-	}
-
-	widgetRect = pixmapRect;
-    x = pixmapRect.Left();
-    y = pixmapRect.Top();
-
-    // set up references to correct drawable and cliprect
-	NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
-	NWSetWidgetState( gWidgetData[m_nScreen].gOptionMenuWidget, nState, stateType );
-	NWSetWidgetState( gWidgetData[m_nScreen].gScrolledWindowWidget, nState, stateType );
-
-	if ( nPart != PART_WINDOW )
-	{
-		gtk_widget_style_get( gWidgetData[m_nScreen].gOptionMenuWidget,
-			"interior_focus",	&bInteriorFocus,
-			"focus_line_width",	&nFocusLineWidth,
-			"focus_padding",	&nFocusPadding,
-			(char *)NULL);
-    }
-    
-    for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it )
-    {
-        clipRect.x = it->Left();
-        clipRect.y = it->Top();
-        clipRect.width = it->GetWidth();
-        clipRect.height = it->GetHeight();
-    
-        if ( nPart != PART_WINDOW )
-        {
-            // Listboxes must paint opaque since some themes have alpha-channel enabled bodies
-            gtk_paint_flat_box( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, GTK_STATE_NORMAL, GTK_SHADOW_NONE, 
-                                &clipRect, m_pWindow, "base", x, y, 
-                                pixmapRect.GetWidth(), pixmapRect.GetHeight() );
-            gtk_paint_box( gWidgetData[m_nScreen].gOptionMenuWidget->style, gdkDrawable, stateType, shadowType, &clipRect,
-                           gWidgetData[m_nScreen].gOptionMenuWidget, "optionmenu",
-                           x+(widgetRect.Left() - pixmapRect.Left()), 
-                           y+(widgetRect.Top() - pixmapRect.Top()),
-                           widgetRect.GetWidth(), widgetRect.GetHeight() );
-            aIndicatorRect = NWGetListBoxIndicatorRect( m_nScreen, nType, nPart, widgetRect, nState, 
-                                                        aValue, rCaption );
-            gtk_paint_tab( gWidgetData[m_nScreen].gOptionMenuWidget->style, gdkDrawable, stateType, shadowType, &clipRect,
-                           gWidgetData[m_nScreen].gOptionMenuWidget, "optionmenutab",
-                           x+(aIndicatorRect.Left() - pixmapRect.Left()), 
-                           y+(aIndicatorRect.Top() - pixmapRect.Top()),
-                           aIndicatorRect.GetWidth(), aIndicatorRect.GetHeight() );
-        }
-        else
-        {
-            shadowType = GTK_SHADOW_IN;
-        
-            gtk_paint_shadow( gWidgetData[m_nScreen].gScrolledWindowWidget->style, gdkDrawable, GTK_STATE_NORMAL, shadowType,
-                &clipRect, gWidgetData[m_nScreen].gScrolledWindowWidget, "scrolled_window",
-                x+(widgetRect.Left() - pixmapRect.Left()), y+(widgetRect.Top() - pixmapRect.Top()),
-                widgetRect.GetWidth(), widgetRect.GetHeight() );
-        }
-    }
-    
-	return( TRUE );
+#if GTK_CHECK_VERSION(2,90,0)
+    gtk_orientable_set_orientation( GTK_ORIENTABLE(widget), orientation );
+#else
+    gtk_toolbar_set_orientation( GTK_TOOLBAR(widget), orientation );
+#endif
 }
 
 BOOL GtkSalGraphics::NWPaintGTKToolbar(
             GdkDrawable* gdkDrawable,
             ControlType, ControlPart nPart,
-			const Rectangle& rControlRectangle,
+            const Rectangle& rControlRectangle,
             const clipList& rClipList,
             ControlState nState, const ImplControlValue& aValue,
 			const OUString& )
 {
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	gint			x, y, w, h;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    gint            x, y, w, h;
     gint            g_x=0, g_y=0, g_w=10, g_h=10;
     bool            bPaintButton = true;
     GtkWidget*      pButtonWidget = gWidgetData[m_nScreen].gToolbarButtonWidget;
     const gchar*    pButtonDetail = "button";
-    GdkRectangle	clipRect;
+    GdkRectangle    clipRect;
     
-	NWEnsureGTKToolbar( m_nScreen );
+    NWEnsureGTKToolbar( m_nScreen );
     if( nPart == PART_BUTTON ) // toolbar buttons cannot focus in gtk
         nState &= ~CTRL_STATE_FOCUSED;
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
     
-	x = rControlRectangle.Left();
+    x = rControlRectangle.Left();
     y = rControlRectangle.Top();
-	w = rControlRectangle.GetWidth();
-	h = rControlRectangle.GetHeight();
+    w = rControlRectangle.GetWidth();
+    h = rControlRectangle.GetHeight();
 
     // handle toolbar
     if( nPart == PART_DRAW_BACKGROUND_HORZ || nPart == PART_DRAW_BACKGROUND_VERT )
     {
-	    NWSetWidgetState( gWidgetData[m_nScreen].gToolbarWidget, nState, stateType );
+        NWSetWidgetState( gWidgetData[m_nScreen].gToolbarWidget, nState, stateType );
 
         GTK_WIDGET_UNSET_FLAGS( gWidgetData[m_nScreen].gToolbarWidget, GTK_SENSITIVE );
         if ( nState & CTRL_STATE_ENABLED )
             GTK_WIDGET_SET_FLAGS( gWidgetData[m_nScreen].gToolbarWidget, GTK_SENSITIVE );
 
         if( nPart == PART_DRAW_BACKGROUND_HORZ )
-            gtk_toolbar_set_orientation( GTK_TOOLBAR(gWidgetData[m_nScreen].gToolbarWidget), GTK_ORIENTATION_HORIZONTAL );
+            set_widget_orientation( gWidgetData[m_nScreen].gToolbarWidget, GTK_ORIENTATION_HORIZONTAL );
         else
-            gtk_toolbar_set_orientation( GTK_TOOLBAR(gWidgetData[m_nScreen].gToolbarWidget), GTK_ORIENTATION_VERTICAL );
+            set_widget_orientation( gWidgetData[m_nScreen].gToolbarWidget, GTK_ORIENTATION_VERTICAL );
     }        
     // handle grip
     else if( nPart == PART_THUMB_HORZ || nPart == PART_THUMB_VERT )
     {
-	    NWSetWidgetState( gWidgetData[m_nScreen].gHandleBoxWidget, nState, stateType );
+        NWSetWidgetState( gWidgetData[m_nScreen].gHandleBoxWidget, nState, stateType );
 
         GTK_WIDGET_UNSET_FLAGS( gWidgetData[m_nScreen].gHandleBoxWidget, GTK_SENSITIVE );
         if ( nState & CTRL_STATE_ENABLED )
@@ -2588,7 +2681,7 @@
         bPaintButton =
             (GTK_BUTTON(pButtonWidget)->relief != GTK_RELIEF_NONE)
             || (nState & CTRL_STATE_PRESSED)
-		    || (nState & CTRL_STATE_ROLLOVER); 
+            || (nState & CTRL_STATE_ROLLOVER); 
         if( aValue.getTristateVal() == BUTTONVALUE_ON )
         {
             pButtonWidget = gWidgetData[m_nScreen].gToolbarToggleWidget;
@@ -2662,7 +2755,7 @@
         }
     }
     
-	return( TRUE );
+    return( TRUE );
 }
 
 //----
@@ -2670,24 +2763,24 @@
 BOOL GtkSalGraphics::NWPaintGTKMenubar(
             GdkDrawable* gdkDrawable,
             ControlType, ControlPart nPart,
-			const Rectangle& rControlRectangle,
+            const Rectangle& rControlRectangle,
             const clipList& rClipList,
             ControlState nState, const ImplControlValue&,
 			const OUString& )
 {
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
     GtkShadowType   selected_shadow_type = GTK_SHADOW_OUT;
-	gint			x, y, w, h;
-    GdkRectangle	clipRect;
+    gint            x, y, w, h;
+    GdkRectangle    clipRect;
     
-	NWEnsureGTKMenubar( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWEnsureGTKMenubar( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
     
-	x = rControlRectangle.Left();
+    x = rControlRectangle.Left();
     y = rControlRectangle.Top();
-	w = rControlRectangle.GetWidth();
-	h = rControlRectangle.GetHeight();
+    w = rControlRectangle.GetWidth();
+    h = rControlRectangle.GetHeight();
 
     if( nPart == PART_MENU_ITEM )
     {
@@ -2749,13 +2842,13 @@
         }
     }
     
-	return( TRUE );
+    return( TRUE );
 }
 
 BOOL GtkSalGraphics::NWPaintGTKPopupMenu(
             GdkDrawable* gdkDrawable,
             ControlType, ControlPart nPart,
-			const Rectangle& rControlRectangle,
+            const Rectangle& rControlRectangle,
             const clipList& rClipList,
             ControlState nState, const ImplControlValue&,
 			const OUString& )
